# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables

class GetFileSystemsResult:
    """
    A collection of values returned by getFileSystems.
    """
    def __init__(__self__, description_regex=None, descriptions=None, ids=None, output_file=None, protocol_type=None, storage_type=None, systems=None, id=None):
        if description_regex and not isinstance(description_regex, str):
            raise TypeError("Expected argument 'description_regex' to be a str")
        __self__.description_regex = description_regex
        if descriptions and not isinstance(descriptions, list):
            raise TypeError("Expected argument 'descriptions' to be a list")
        __self__.descriptions = descriptions
        """
        A list of FileSystem descriptions.
        """
        if ids and not isinstance(ids, list):
            raise TypeError("Expected argument 'ids' to be a list")
        __self__.ids = ids
        """
        A list of FileSystem Id.
        """
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        __self__.output_file = output_file
        if protocol_type and not isinstance(protocol_type, str):
            raise TypeError("Expected argument 'protocol_type' to be a str")
        __self__.protocol_type = protocol_type
        """
        ProtocolType block of the FileSystem
        """
        if storage_type and not isinstance(storage_type, str):
            raise TypeError("Expected argument 'storage_type' to be a str")
        __self__.storage_type = storage_type
        """
        StorageType block of the FileSystem.
        """
        if systems and not isinstance(systems, list):
            raise TypeError("Expected argument 'systems' to be a list")
        __self__.systems = systems
        """
        A list of VPCs. Each element contains the following attributes:
        """
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        __self__.id = id
        """
        id is the provider-assigned unique ID for this managed resource.
        """
class AwaitableGetFileSystemsResult(GetFileSystemsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFileSystemsResult(
            description_regex=self.description_regex,
            descriptions=self.descriptions,
            ids=self.ids,
            output_file=self.output_file,
            protocol_type=self.protocol_type,
            storage_type=self.storage_type,
            systems=self.systems,
            id=self.id)

def get_file_systems(description_regex=None,ids=None,output_file=None,protocol_type=None,storage_type=None,opts=None):
    """
    This data source provides FileSystems available to the user.
    
    > NOTE: Available in 1.35.0+
    
    :param str description_regex: A regex string to filter the results by the ：FileSystem description.
    :param list ids: A list of FileSystemId.
    :param str protocol_type: Filter results by a specific ProtocolType. 
    :param str storage_type: Filter results by a specific StorageType. 

    > This content is derived from https://github.com/terraform-providers/terraform-provider-alicloud/blob/master/website/docs/d/nas_file_systems.html.markdown.
    """
    __args__ = dict()

    __args__['descriptionRegex'] = description_regex
    __args__['ids'] = ids
    __args__['outputFile'] = output_file
    __args__['protocolType'] = protocol_type
    __args__['storageType'] = storage_type
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = utilities.get_version()
    __ret__ = pulumi.runtime.invoke('alicloud:nas/getFileSystems:getFileSystems', __args__, opts=opts).value

    return AwaitableGetFileSystemsResult(
        description_regex=__ret__.get('descriptionRegex'),
        descriptions=__ret__.get('descriptions'),
        ids=__ret__.get('ids'),
        output_file=__ret__.get('outputFile'),
        protocol_type=__ret__.get('protocolType'),
        storage_type=__ret__.get('storageType'),
        systems=__ret__.get('systems'),
        id=__ret__.get('id'))
