# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables

class Network(pulumi.CustomResource):
    cidr_block: pulumi.Output[str]
    """
    The CIDR block for the VPC.
    """
    description: pulumi.Output[str]
    """
    The VPC description. Defaults to null.
    """
    name: pulumi.Output[str]
    """
    The name of the VPC. Defaults to null.
    """
    resource_group_id: pulumi.Output[str]
    """
    The Id of resource group which the VPC belongs.
    """
    route_table_id: pulumi.Output[str]
    """
    The route table ID of the router created by default on VPC creation.
    """
    router_id: pulumi.Output[str]
    """
    The ID of the router created by default on VPC creation.
    """
    router_table_id: pulumi.Output[str]
    tags: pulumi.Output[dict]
    """
    A mapping of tags to assign to the resource.
    """
    def __init__(__self__, resource_name, opts=None, cidr_block=None, description=None, name=None, resource_group_id=None, tags=None, __props__=None, __name__=None, __opts__=None):
        """
        Create a Network resource with the given unique name, props, and options.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cidr_block: The CIDR block for the VPC.
        :param pulumi.Input[str] description: The VPC description. Defaults to null.
        :param pulumi.Input[str] name: The name of the VPC. Defaults to null.
        :param pulumi.Input[str] resource_group_id: The Id of resource group which the VPC belongs.
        :param pulumi.Input[dict] tags: A mapping of tags to assign to the resource.

        > This content is derived from https://github.com/terraform-providers/terraform-provider-alicloud/blob/master/website/docs/r/vpc.html.markdown.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            if cidr_block is None:
                raise TypeError("Missing required property 'cidr_block'")
            __props__['cidr_block'] = cidr_block
            __props__['description'] = description
            __props__['name'] = name
            __props__['resource_group_id'] = resource_group_id
            __props__['tags'] = tags
            __props__['route_table_id'] = None
            __props__['router_id'] = None
            __props__['router_table_id'] = None
        super(Network, __self__).__init__(
            'alicloud:vpc/network:Network',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, cidr_block=None, description=None, name=None, resource_group_id=None, route_table_id=None, router_id=None, router_table_id=None, tags=None):
        """
        Get an existing Network resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.
        
        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cidr_block: The CIDR block for the VPC.
        :param pulumi.Input[str] description: The VPC description. Defaults to null.
        :param pulumi.Input[str] name: The name of the VPC. Defaults to null.
        :param pulumi.Input[str] resource_group_id: The Id of resource group which the VPC belongs.
        :param pulumi.Input[str] route_table_id: The route table ID of the router created by default on VPC creation.
        :param pulumi.Input[str] router_id: The ID of the router created by default on VPC creation.
        :param pulumi.Input[dict] tags: A mapping of tags to assign to the resource.

        > This content is derived from https://github.com/terraform-providers/terraform-provider-alicloud/blob/master/website/docs/r/vpc.html.markdown.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()
        __props__["cidr_block"] = cidr_block
        __props__["description"] = description
        __props__["name"] = name
        __props__["resource_group_id"] = resource_group_id
        __props__["route_table_id"] = route_table_id
        __props__["router_id"] = router_id
        __props__["router_table_id"] = router_table_id
        __props__["tags"] = tags
        return Network(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

